<?php
/*********************************************************************
*@filename assets_printer_controller.php
*@description
*@note
*@histories  rivision	author		date		 comment

********************************************************************/
class AssetsDriverController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv');
	var $uses=array('Hrdprt','Grpauth','Hstloghead','Host','Rlthstgrp','Group');
	var $layout='assets';


	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('prt title',$return = true);// 'LVシステム管理／全体設定／センサー';
		//================================yin c=======================
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
			//	    		debug($_POST['forHideVar']);
			//	    		echo "forHideVar===".$_POST['forHideVar']."++++++1++++<br>";
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
			//	    		debug($_POST['forHideVar1']);
			//	    		echo "forHideVar1===".$_POST['forHideVar1']."+++++2+++++<br>";
		}
		//		debug($_POST, true);
		//================================yin c=======================

	}

	function index($group=null,$errorMessage=null)
	{		
		if($group!=null){//HW台帳から戻ってきた
			$my_group_id =$this->_getUserGroup();
			$ginfo = $this->Group->find(array("Group.id" => $this->Lv->spec_char_dbm($group)));
			if($my_group_id == 1 
			|| $group == $my_group_id 
			|| $ginfo['Group']['parent_id'] == $my_group_id)
			{
				$this->set('selectonload', true);
				
				$this->set('group_id',$group);
				$this->set('fromhw',true);
			}
		}

		//    	$glist = array(0 => __('whole',$return = true)); // 'すべて'
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		//		$glist[0] =  __('whole',$return = true);
		ksort($glist);
		$this->set('glist',$glist);
		if($errorMessage != null){
			echo "<div id='errmsg'>".
			__('index_error',$return = true).
			"</div>";
		}

	}
	function listdriver($csv = null, $group_id=null)
	{
		$this->layout="ajax";
		
		//入力データ取得
		if($group_id!=null){
			$this->data['Group']['group_name'] = $group_id;
		}
		$group = $this->data['Group']['group_name'];

		if(is_null($group)){
			$this->set('err', array(__('select_user_name',$return = true)));
			$this->render('drivers');
			exit;
		}
		
		$keyword = $this->data['Hrdprt']['sinput'];
		$keyword2 = $this->Lv->spec_char_dbm($keyword);
		$keyword_pref = "";
		if(isset($this->data['Selector']['input_keyword_check'])){
			$keyword_pref = "%";
		}
//debug($this->data);

		//取得条件設定
		$asso = array(
			'Asthrd : asthrds' => array('Hrdprt.hardware_id = Asthrd.id'),
			'Rlthstgrp : rlthstgrps' => array('Asthrd.host_id = Rlthstgrp.host_id'),
		) ;
		
		$fields = array(
		'Hrdprt.driver_name',
		'count(Hrdprt.driver_name) as Hrdprt__count'
		);
		
		$group_ids = "";
		$glist = $this->Grpauth->getChildrenByParent($group);
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 

		$criteria[]="Rlthstgrp.group_id in (".$group_ids.")";
		$criteria[]="Hrdprt.driver_name like '".$keyword_pref.$keyword2."%'";
		$criteria["GROUP BY"]="Hrdprt.driver_name";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Hrdprt->findByAsso($criteria, $fields, 'Hrdprt.driver_name', null, null, $asso);
		
			$this->csvdown($Hrdprts,1);exit;
		}else{
			$this->Pagination->show = 20;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_printer/listdriver', 'modelClass'=>'Hrdprt', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Hrdprt.driver_name', 'Hrdprt.count')));
			$Hrdprts = $this->Hrdprt->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
		}		
//debug($Hrdprts);

		$criteria2[]="Rlthstgrp.group_id in (".$group_ids.")";
		$criteria2[]="Hrdprt.driver_name like '".$keyword_pref.$keyword2."%'";
		$criteria2["GROUP BY"]="Hrdprt.hardware_id";
		$hardware_ids = $this->Hrdprt->findByAsso($criteria2, array("Hrdprt.hardware_id"), null, null, null, $asso);
		

		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($hardware_ids));
		
		$this->set('group_id',$group);	
		$this->render('drivers');
	}

	function printer($csv, $driver_name, $group)
	{
		$this->layout="ajax";
		
		//入力データ取得
		//$group = $this->data['Group']['group_name'];
		$keyword = $this->data['Hrdprt']['sinput'];
		$driver = $this->Lv->url_param_decode2($driver_name);
		$this->data['Select']['driver'] = $driver_name;
		
		//取得条件設定
		$asso = array(
			'Asthrd : asthrds' => array('Hrdprt.hardware_id = Asthrd.id'),
			'Rlthstgrp : rlthstgrps' => array('Asthrd.host_id = Rlthstgrp.host_id'),
		) ;
		
		$fields = array(
		'Hrdprt.print_name',
		'count(Hrdprt.print_name) as Hrdprt__count',
		'Hrdprt.driver_name',
		);
		
		$group_ids = "";
		$glist = $this->Grpauth->getChildrenByParent($group);
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 

		$criteria[]="Rlthstgrp.group_id in (".$group_ids.")";
		$criteria[]="Hrdprt.driver_name = '".$this->Lv->spec_char_dbm($driver)."'";
		$criteria["GROUP BY"]="Hrdprt.print_name";

		//取得
		if($csv == 'csv'){
			$Hrdprts = $this->Hrdprt->findByAsso($criteria, $fields, 'Hrdprt.print_name', null, null, $asso);
		
			$this->csvdown($Hrdprts,2);exit;
		
		}else{
			$this->Pagination->show = 20;
			list($order,$limit,$page) = $this->Pagination->init($criteria, null, array('ajaxDivUpdate'=>'lists', 'url'=>'/assets_printer/printer', 'modelClass'=>'Hrdprt', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy('Hrdprt.driver_name')));
			$Hrdprts = $this->Hrdprt->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
		}
//debug($Hrdprts);
		$criteria2[]="Rlthstgrp.group_id in (".$group_ids.")";
		$criteria2[]="Hrdprt.driver_name = '".$this->Lv->spec_char_dbm($driver)."'";
		$criteria2["GROUP BY"]="Hrdprt.hardware_id";
		$hardware_ids = $this->Hrdprt->findByAsso($criteria2, array("Hrdprt.hardware_id"), null, null, null, $asso);
		


		//表示データ設定
		!empty($Hrdprts)?$this->set('data',$Hrdprts):$this->set('data',"");
		$this->set('device_count',count($hardware_ids));
		
		$this->set('group_id',$group);
		$this->set('driver_name',$driver_name);
		$this->render('printers');
	}
	function csvdown($data,$flag)
	{
		//$parent = $this->data['Selector']['parent_group'];
		$group = $this->data['Group']['group_name'];
		
		$this->data['Csv']['group'] = $this->groupName($group);
			
		$this->data['Csv']['sinput'] = $this->data['Hrdprt']['sinput'];
		
		if($flag == 2)
			$this->data['Csv']['driver'] = $this->data['Select']['driver'];
		else
			$this->data['Csv']['driver'] = "";
			
			
		require_once( 'csv/DlFactory.php' );
		
		$filename="";


		$csv = DlFactory::create("assets_printer");
		if($flag == 1){
			$array = array(
			"Hrdprt/driver_name"=>__('driver_name', $return = true),
			"Hrdprt/count"=>__('count', $return = true),
			);
			
			$filename=__('csv_file1',$return=true);
		}
		elseif($flag == 2){
			$array = array(
			"Hrdprt/print_name"=>__('printer_name', $return = true),
			"Hrdprt/count"=>__('count', $return = true),
			);
			
			$filename=__('csv_file2',$return=true);
		}

		$csv->special_cols=$array;
		$csv->sendCSVFile($data,$this->data, $filename);

		exit;
	}
	
	function groupName($group_id)
	{
		$criteria= array("Group.id" => $this->Lv->spec_char_dbm($group_id));
		$group_n= $this->Group->findAll($criteria);
		$group_name = $group_n[0]["Group"]["group_name"];
		return $group_name;
	}
}
?>