<?php
class AttendanceViewController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv', 'Cache');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host', 'Rlthstgrp','Grpauth', 'Authority','Rltuserauth','User','Configure','Validation',
	'Employee', 'Seatlayout', 'Siteinfo', 'Hstattendance', 'Workstatus', 'Draftlayout', 'Grpattendconf', 'Remotehost');
	var $layout='attendview';
	
	var $cacheAction = array(
		"attendance_view/status"  => "10 seconds");
								
	function beforeFilter()
	{
	//	parent::beforeFilter();
		$this->pageTitle =__('menu_uptime',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function test(){
				$this->pageTitle =__('title',$return = true);
		
		$sites = $this->Siteinfo->findAll(null,null,"showorder ASC");
		$keys = Set::extract($sites, '{n}.Siteinfo.id');
		$vals = Set::extract($sites, '{n}.Siteinfo.site_name');
		$slist = array_combine($keys, $vals);
		//$slist['']="";
		//ksort($slist);
		$this->set('slist',$slist);
		
		$status = $this->Workstatus->findAll(null, array("Workstatus.name","Workstatus.forecolor","Workstatus.backcolor"),"showorder ASC");
		$this->set('status',$status);
		
		
		$criteria[] = "Siteinfo.defview = 1";
		$defsite = $this->Siteinfo->find($criteria, "id");
		if(!empty($defsite)){
			$this->set('siteid',$defsite['Siteinfo']['id']);
			$this->data['site']['select'] = $defsite['Siteinfo']['id'];
			$this->set('draft', 0);
		}
		
		if(!is_null($siteid)){
			$this->set('siteid',$siteid);
			$this->data['site']['select'] = $siteid;
			$this->set('draft', $draftid);
		}
		
		$dir=DATABASE_PATH."\\..\\custom.ini";
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array)) {
			if (isset($ini_array['Manual']['link_title'])) {
				$this->set('link_title', $ini_array['Manual']['link_title']);
			}
			if (isset($ini_array['Manual']['link_url'])) {
				$this->set('link_url', $ini_array['Manual']['link_url']);
			}
		}
			
	}
	//////////レイアウト編集
	function index($siteid=null,$draftid=null)
	{
		$this->pageTitle =__('title',$return = true);
		
		$sites = $this->Siteinfo->findAll(null,null,"showorder ASC");
		$keys = Set::extract($sites, '{n}.Siteinfo.id');
		$vals = Set::extract($sites, '{n}.Siteinfo.site_name');
		$slist = array_combine($keys, $vals);
		//$slist['']="";
		//ksort($slist);
		$this->set('slist',$slist);
		
		$status = $this->Workstatus->findAll(null, array("Workstatus.name","Workstatus.forecolor","Workstatus.backcolor"),"showorder ASC");
		$this->set('status',$status);
		
		
		$criteria[] = "Siteinfo.defview = 1";
		$defsite = $this->Siteinfo->find($criteria, "id");
		if(!empty($defsite)){
			$this->set('siteid',$defsite['Siteinfo']['id']);
			$this->data['site']['select'] = $defsite['Siteinfo']['id'];
			$this->set('draft', 0);
		}
		
		if(!is_null($siteid)){
			$this->set('siteid',$siteid);
			$this->data['site']['select'] = $siteid;
			$this->set('draft', $draftid);
		}
		
		$conf= $this->Grpattendconf->find("Grpattendconf.id=1");
		if(!empty($conf) && !is_null($conf['Grpattendconf']['refresh'])){
			$this->set('refresh',$conf['Grpattendconf']['refresh']);
		}else
			$this->set('refresh', 300);
		
		$dir=DATABASE_PATH."\\..\\custom.ini";
		$ini_array = parse_ini_file($dir,true);
		if (!empty($ini_array)) {
			if (isset($ini_array['Manual']['link_title'])) {
				$this->set('link_title', $ini_array['Manual']['link_title']);
			}
			if (isset($ini_array['Manual']['link_url'])) {
				$this->set('link_url', $ini_array['Manual']['link_url']);
			}
		}
			
		$this->render('index');
	}
	
	function layout($site_id)
	{
		$this->layout="attendance";
		$this->set('siteid', $site_id);
	}
	
	function getlayout($site_id=1, $draft = 0)
	{
		$asso = array(
			'Employee : employees : LEFT' => array('Employee.id = Seatlayout.emp_id')
		) ;
		if($draft > 0){
			$asso['Draftlayout : draftlayouts : LEFT'] = array(
				'Seatlayout.id = Draftlayout.seat_id', 
				'Seatlayout.site_id = Draftlayout.site_id',
				"Draftlayout.draft_id = ".$draft
				);
		}
		
		//取得項目
		$fields = array(
			'Seatlayout.id as id',
			'Employee.id as eid',
			'Employee.id_name as idname',
			'Employee.name as ename',
			'Employee.name_eng as nameeng',
			'Employee.linenumber as line',
			'Seatlayout.name as iname',
			'Seatlayout.itemcolor as icolor',
			'Seatlayout.bordercolor as bcolor',
			'Seatlayout.size_x as size_x',
			'Seatlayout.size_y as size_y',
			'Seatlayout.linestyle as linestyle',
		);
		if($draft > 0){
			$fields[] = '(case when Draftlayout.pos_x is null then -1 else Draftlayout.pos_x end) as pos_x';
			$fields[] = '(case when Draftlayout.pos_y is null then -1 else Draftlayout.pos_y end) as pos_y';
		}else{
			$fields[] = 'Seatlayout.pos_x as pos_x';
			$fields[] = 'Seatlayout.pos_y as pos_y';
		}
		$criteria = array("1=1");
		$criteria[]="Seatlayout.site_id = ".$site_id;

		//取得
		$Seatlayout = $this->Seatlayout->findByAsso($criteria, $fields, null, null, null, $asso);
		
		return $Seatlayout;
	}
	
	function search($site_id=1)
	{
		$this->layout="ajax";
		
		$draft= json_decode($_POST['draft']);
		
		//取得
		$Seatlayout = $this->getlayout($site_id, $draft);
		
		//exit;
		header("Content-Type: application/json; charset=utf-8");
		$json = json_encode( $Seatlayout ) ;
		$this->set(compact('json'));
	}
	
	function view($site_id=1, $draft = 0)
	{
		$this->layout="ajax";

		//取得
		$Seatlayout = $this->getlayout($site_id, $draft);
		
		$this->set('spans', $Seatlayout);
	}
	
	function status($siteid)
	{
		$this->layout="ajax";
		
		$set= $this->Grpattendconf->find("Grpattendconf.id=1");
		$threshold = 0;
		if(isset($set['Grpattendconf']['threshold']))
			$threshold = $set['Grpattendconf']['threshold'];
		
		//ステータスの取得
		$asso = array(
			'Employee : employees' => array('Employee.id = Seatlayout.emp_id'),
			'Employeeaccount : employeeaccounts' => array('Employee.id = Employeeaccount.employee_id','Employeeaccount.number = 0'),
			'Host : hosts' => array('Host.id = Employeeaccount.host_id'),
			'Hstattendance : hstattendance' => array('Host.id = Hstattendance.host_id'),
			'Workstatus : workstatus' => array('Workstatus.id = Hstattendance.status'),
			'Siteinfo : siteinfo' => array('Siteinfo.id = Seatlayout.site_id')		
		) ;
		
		//取得項目
		$fields = array(
			'Seatlayout.id as id',
			'Hstattendance.status as status',
			//'TIMESTAMPDIFF(MINUTE, Hstattendance.lasttime, now()) as minutes',
			'(case when Hstattendance.status = 3 then TIMESTAMPDIFF(MINUTE, Hstattendance.lasttime - INTERVAL '.$threshold.' SECOND, now()) else TIMESTAMPDIFF(MINUTE, Hstattendance.lasttime, now()) end) as minutes',
			'Workstatus.backcolor as bcolor',
			'Workstatus.forecolor as fcolor',
			'Workstatus.name as name'
		);

		$criteria = array("1=1");
		$criteria[]="Seatlayout.site_id = ".$siteid;
		$criteria[]="Employee.status = 1";//有効な従業員

		//取得
		$status = $this->Seatlayout->findByAsso($criteria, $fields, null, null, null, $asso);
//var_dump($status);
		header("Content-Type: application/json; charset=utf-8");
		/*$data['status'] = $status;
		$data['options'] = array('reload' => $reload);
		$json = json_encode( $data ) ;
		$this->set(compact('json'));*/
		
		$json = json_encode( $status ) ;
		$this->set(compact('json'));
	}
	
	function reload()
	{
		$this->layout="ajax";
		
		$reload = false;
		$addr = $_SERVER["REMOTE_ADDR"];
		$ra= $this->Remotehost->find("Remotehost.name='".$addr."'");
		if(!empty($ra)){
			if($ra['Remotehost']['reload'] == 1)
				$reload = true;
		}
		
		if(empty($ra) || $reload == true){
			$ra = array(
				'Remotehost' => array(
						'name' => $addr,
						'reload' => 0,
					)
				); 		
			$this->Remotehost->save($ra);
		}

		header("Content-Type: application/json; charset=utf-8");
		$data = array('reload' => $reload);
		$json = json_encode( $data ) ;
		$this->set(compact('json'));
		$this->render('status');
	}
}
?>